include \masm32\include\masm32rt.inc
WinMain proto :DWORD, :DWORD, :DWORD, :DWORD
DWordToString proto :DWORD, :DWORD
GetPrime proto :DWORD
GetTimeDifference proto :DWORD, :DWORD, :DWORD
TimeToString proto :SYSTEMTIME, :DWORD
.data
	TimeString Byte 100 dup (0)
.data?
	Mem1 DWORD ?
	Mem2 DWORD ?
	hInstance DWORD ?
	hEdit1 DWORD ?
	hButton1 DWORD ?
	CommandLine DWORD ?
.const
	PrimAnz = 100000
	memsz = PrimAnz * 4
	writesz = PrimAnz * 12 + 1
	EditID1 equ 100
	ButtonID1 equ 200
.code

start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT	
	invoke ExitProcess, NULL
;#############################################################################
;#############################################################################
;#############################################################################
WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize, SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground, COLOR_WINDOW+1
	mov   wc.lpszMenuName, NULL
	mov   wc.lpszClassName, chr$("Window")
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
	mov   wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,NULL,chr$("Window"),chr$("Primzahlen berechnen"),\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd, eax
	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	.while TRUE
		invoke GetMessage, addr msg, NULL, 0, 0
		.BREAK .IF (!eax)
		invoke TranslateMessage, addr msg
		invoke DispatchMessage, addr msg
	.endw
	mov     eax, msg.wParam
	ret
WinMain endp
;#############################################################################
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	local rect :RECT, x1 :DWORD, y1 :DWORD, x2 :DWORD, y2 :DWORD 
	local time1 :SYSTEMTIME, time2 :SYSTEMTIME, Zeit3 :SYSTEMTIME
	.if uMsg == WM_CREATE
		invoke GetClientRect, hWnd, ADDR rect
		mov x1, 0
		mov y1, 100
		mov eax, rect.right
		mov x2, eax
		mov eax, rect.bottom
		sub eax, 100
		mov y2, eax
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("EDIT"), NULL,\
    	WS_CHILD or WS_VISIBLE or WS_BORDER or WS_VSCROLL or ES_READONLY	or ES_MULTILINE	,\
 			x1, y1, x2, y2, hWnd, EditID1, hInstance, NULL
 		mov  hEdit1, eax
 		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("BUTTON"), chr$("Test"),\
    	WS_CHILD or WS_VISIBLE or BS_TEXT, 20, 20, 150, 40, hWnd, ButtonID1, hInstance, NULL
    mov hButton1, eax	
;----------------------------------------------------------------------------- 		
 	.elseif uMsg == WM_CLOSE		
 		invoke	DestroyWindow, hWnd	
;----------------------------------------------------------------------------- 		
	.elseif uMsg == WM_DESTROY
		invoke PostQuitMessage, NULL
;-----------------------------------------------------------------------------
	.elseif uMsg==WM_COMMAND
		.if wParam == ButtonID1
			mov Mem1, alloc(memsz)
  		mov Mem2, alloc(writesz)
  		invoke GetLocalTime, addr time1
  		invoke GetPrime, Mem1
  		mov esi, Mem1
  		mov edi, Mem2
  		xor ecx, ecx

			@@:
				invoke DWordToString, [esi+ecx], edi
				add edi, eax
				add edi, 1
				mov byte ptr [edi], 32
				add edi, 1
  			add ecx, 4
  		cmp ecx, memsz
  		jb @B
  		sub edi, 1
  		mov byte ptr [edi], 0
			invoke GlobalFree, Mem1
			invoke SetWindowText, hEdit1, Mem2
			invoke GlobalFree, Mem2
			invoke GetLocalTime, addr time2
			invoke GetTimeDifference, addr time1, addr time2, addr Zeit3
			invoke TimeToString, Zeit3, addr TimeString
			invoke MessageBox,NULL , addr TimeString, chr$("Zeitmessung"), NULL
			mov byte ptr TimeString, 0
		.endif
	.else
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp
comment *>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
														DWordToString													
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*
DWordToString proc USES ecx edx ebx esi edi _Value :DWORD, _Mem :DWORD
	mov esi, _Value
	mov edi, _Mem
	xor ecx, ecx
	
	cmp esi, 10
	jb @1
		
	cmp esi, 100
	jb @2
	
	cmp esi, 1000
	jb @3
	
	cmp esi, 10000
	jb @4
	
	cmp esi, 100000
	jb @5
	
	cmp esi, 1000000
	jb @6
	
	cmp esi, 10000000
	jb @7
	
	cmp esi, 100000000
	jb @8
	
	cmp esi, 1000000000
	jb @9
	
	
	; digit 10
	mov eax, esi
	xor edx, edx
	mov ebx, 1000000000
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	cmp al, 0
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1

	
	; digit 9
	@9:
	mov eax, esi
	xor edx, edx
	mov ebx, 100000000
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1	

	
	; digit 8
	@8:
	mov eax, esi
	xor edx, edx
	mov ebx, 10000000
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1
	

	; digit 7
	@7:
	mov eax, esi
	xor edx, edx
	mov ebx, 1000000
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1	


	; digit 6
	@6:
	mov eax, esi
	xor edx, edx
	mov ebx, 100000
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1	
	
	
	; digit 5
	@5:
	mov eax, esi
	xor edx, edx
	mov ebx, 10000
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1
	
	
	; digit 4
	@4:
	mov eax, esi
	xor edx, edx
	mov ebx, 1000
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1
	
	
	; digit 3
	@3:
	mov eax, esi
	xor edx, edx
	mov ebx, 100
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1
	
	
; digit 2
	@2:
	mov eax, esi
	xor edx, edx
	mov ebx, 10
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	add ecx, 1
	
; digit 1	
	@1:
	mov eax, esi
	xor edx, edx
	mov ebx, 1
	div ebx
	push eax
	mul ebx
	sub esi, eax
	pop eax
	add al, 48
	mov byte ptr [edi+ecx], al
	
	mov eax, ecx
	ret
DWordToString endp
comment *>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
																GetPrime						
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*
GetPrime proc Mem_ :DWORD
						local memsz_ :DWORD
						local IsPrim_ :DWORD
						local Value_ :DWORD
	pushad
	mov edi, Mem_
	invoke GlobalSize, edi
	mov memsz_, eax
	sub memsz_, 4
	ASSUME edi: ptr DWORD
	mov [edi+0], 2 							
	mov [edi+4], 3 							
	mov ecx, 4									
	xor esi, esi								
	mov ebx, 4									
	.while ebx < memsz_
		mov eax, [edi+esi]
		mul eax										
		.if eax <= [edi+ebx]
			add esi, 4
		.endif
		mov Value_, ecx
		push ecx
		push eax
		push edx
		xor ecx, ecx
		mov IsPrim_, 1
		.while ecx <= esi
			mov eax, Value_
			xor edx, edx
			div [edi+ecx]
			.if edx == 0
				mov IsPrim_, 0
				.break
			.endif
			add ecx, 4
		.endw
		pop edx
		pop eax
		pop ecx
		.if IsPrim_ == 1
			add ebx, 4
			push eax
			mov eax, Value_
			mov [edi+ebx], eax
			pop eax
		.endif		
		add ecx, 1
	.endw
	ASSUME edi: NOTHING
	popad
	ret
GetPrime endp

comment *>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
														GetTimeDifference												
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*
GetTimeDifference proc USES eax edx ecx esi edi, _time1 :DWORD, _time2 :DWORD, _time3 :DWORD
	Local _Remainder :SWORD
	mov eax, _time1
	mov edx, _time2
	mov ecx, _time3
	ASSUME eax: ptr word
	ASSUME edx: ptr word
	ASSUME ecx: ptr word
;	Millisekunden
	mov di, [eax+14]
	mov si, [edx+14]	
	mov _Remainder, 0
	sub si, di
	cmp si, -1
	jg @F
	add _Remainder, 1
	add si, 1000
	@@:
	mov [ecx+14], si

;	Sekunden
	mov di, [eax+12]
	mov si, [edx+12]	
	sub si, di
	sub si, _Remainder
	mov _Remainder, 0
	cmp si, -1
	jg @F
	add _Remainder, 1
	add si, 60
	@@:
	mov [ecx+12], si
	
;	Minuten
	mov di, [eax+10]
	mov si, [edx+10]	
	sub si, di
	sub si, _Remainder
	mov _Remainder, 0
	cmp si, -1
	jg @F
	add _Remainder, 1
	add si, 60
	@@:
	mov [ecx+10], si
	
	;	Stunden
	mov di, [eax+8]
	mov si, [edx+8]	
	sub si, di
	sub si, _Remainder
	mov _Remainder, 0
	cmp si, -1
	jg @F
	add _Remainder, 1
	add si, 24
	@@:
	mov [ecx+8], si
	
	;	Tage
	mov di, [eax+6]
	mov si, [edx+6]	
	sub si, di
	sub si, _Remainder
	mov _Remainder, 0
	mov [ecx+6], si
	ASSUME eax: NOTHING
	ASSUME edx: NOTHING
	ASSUME ecx: NOTHING
	ret
GetTimeDifference endp	

comment *>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
														TimeToString												
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*
TimeToString proc USES eax _time :SYSTEMTIME, _TimeString :DWORD
	invoke szCatStr, _TimeString, chr$("Zeitdifferenz: ")
	movzx eax, _time.wDay
	invoke szCatStr, _TimeString, str$(eax)
	invoke szCatStr, _TimeString, chr$("day ")
	
	movzx eax, _time.wHour
	cmp eax, 9
	jg @F
	push eax
	invoke szCatStr, _TimeString, chr$("0")
	pop eax
	@@:
	invoke szCatStr, _TimeString, str$(eax)
	invoke szCatStr, _TimeString, chr$(":")
	
	movzx eax, _time.wMinute
	cmp eax, 9
	jg @F
	push eax
	invoke szCatStr, _TimeString, chr$("0")
	pop eax
	@@:
	invoke szCatStr, _TimeString, str$(eax)
	invoke szCatStr, _TimeString, chr$(":")
	
	movzx eax, _time.wSecond
	cmp eax, 9
	jg @F
	push eax
	invoke szCatStr, _TimeString, chr$("0")
	pop eax
	@@:
	invoke szCatStr, _TimeString, str$(eax)
	invoke szCatStr, _TimeString, chr$(".")
	
	movzx eax, _time.wMilliseconds
	cmp eax, 9
	jg @F
	push eax
	invoke szCatStr, _TimeString, chr$("0")
	pop eax
	@@:
	cmp eax, 99
	jg @F
	push eax
	invoke szCatStr, _TimeString, chr$("0")
	pop eax
	@@:	
	push eax
	invoke szCatStr, _TimeString, str$(eax)
	pop eax
	ret
TimeToString endp
end start